local function prefix_mod_int(str,pn)
	if type(pn) == 'number' then pn = 'PlayerNumber_P'.. pn; end
	local state = GAMESTATE:GetPlayerState(pn);
	local mods = state:GetPlayerOptionsString('ModsLevel_Song');
	state:SetPlayerOptions('ModsLevel_Song',mods ..','.. str);
end

local function prefix_mod(str)
	for pn in ivalues(GAMESTATE:GetEnabledPlayers()) do
		prefix_mod_int(str,pn);
	end
end

local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)

		checked = false;
		fgcurcommand = 1;

		prefix_inc = 1;
		prefix_time = 0;

		prefix_curmessage = 1;
		prefix_messages = {
			{72.913,'Alert'},
			{89.278,'Wag'},
		};

		prefix_mods = {
			{111.515,200,'*0.5 No Reverse','end'},
		};

		prefix_plr = {};

		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)

		prefix_inc = prefix_inc + 1;
		local beat = GAMESTATE:GetSongBeat();

		--------------------------------------------------------
		-- Mod Reader Original by TaroNuke. Edited by WinDEU. --
		--------------------------------------------------------
		for i,v in pairs(prefix_mods) do
			if prefix_time >= v[1] then
				if (v[4] == 'len' and prefix_time <= v[1]+v[2]) or (v[4] == 'end' and prefix_time <= v[2]) then
					if table.getn(v) == 5 then
						prefix_mod_int(v[3],v[5]);
					else
						prefix_mod(v[3]);
					end
				end
			end
		end



		if beat >= 0 and not checked then
			checked = true;
			table.insert(prefix_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
			table.insert(prefix_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
		end

		if beat >= 260 and fgcurcommand == 1 then
			for i,v in pairs(prefix_plr) do
				local multi = -1; if i == 2 then multi = 1; end
				if v then
					v:stopeffect();
					v:decelerate(3.357);
					v:x(SCREEN_CENTER_X+multi*160*(SCREEN_WIDTH/640));
				end
			end
			fgcurcommand = fgcurcommand + 1;
		end



		-------------------
		-- Beat Specific --
		-------------------
		if beat >= 175 and beat < 260 then
			local multi2 = 1; if math.mod(prefix_inc,2) == 0 then multi2 = -1; end
			for i,v in pairs(prefix_plr) do
				local multi = -1; if i == 2 then multi = 1; end
				if v then
					if GAMESTATE:GetNumPlayersEnabled() == 1 then
						v:x(SCREEN_CENTER_X+math.cos((beat+1)*math.pi/4)*160*(SCREEN_WIDTH/640)*multi*multi2);
					else
						v:x(SCREEN_CENTER_X+math.cos((beat+1)*math.pi/4)*160*(SCREEN_WIDTH/640)*multi2);
					end
				end
			end
		end

		if beat >= 176 and beat < 260 then
			if math.mod(beat,4) < 2 then
				prefix_mod('*2 No Reverse');
			else
				prefix_mod('*2 Reverse');
			end
		end

		if beat >= 207 and beat < 260 then
			local multi2 = 1; if math.mod(prefix_inc,2) == 0 then multi2 = -1; end
			for i,v in pairs(prefix_plr) do
				local multi = -1; if i == 2 then multi = 1; end
				if v then
					if GAMESTATE:GetNumPlayersEnabled() == 1 then
						v:wag();
						v:effectmagnitude(0,0,auxvar:getaux()*multi*multi2);
						v:effectperiod(2);
					else
						v:wag();
						v:effectmagnitude(0,0,auxvar:getaux()*multi2);
						v:effectperiod(2);
					end
				end
			end
		end



		--------------------
		-- Message Reader --
		--------------------
		if prefix_curmessage <= table.getn(prefix_messages) then
			if prefix_time >= prefix_messages[prefix_curmessage][1] then
				MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
				prefix_curmessage = prefix_curmessage + 1;
			end
		end

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="test",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'music';playcommand,'SetTime';visible,false),
	SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
};

t[#t+1] = Def.Quad{
	InitCommand=function(self) auxvar = self; self:visible(false); end,
	WagMessageCommand=cmd(stoptweening;linear,26.853;aux,30),
	AlertMessageCommand=function()
		SCREENMAN:SystemMessage('How do you like ITG MODS?');
	end,
};

return t;