for pn in ivalues(GAMESTATE:GetEnabledPlayers()) do
	local bpms = GAMESTATE:GetCurrentSong():GetDisplayBpms();
	local state = GAMESTATE:GetPlayerState(pn);
	local options = state:GetPlayerOptions('ModsLevel_Preferred');
	if options:MaxScrollBPM() ~= 0 then
		state:GetPlayerOptions('ModsLevel_Song'):XMod(math.floor(options:MaxScrollBPM() + 0.5) / bpms[2],99999);
elseif options:TimeSpacing() ~= 0 then
		state:GetPlayerOptions('ModsLevel_Song'):XMod(math.floor(options:ScrollBPM() + 0.5) / bpms[2],99999);
	end
end



local function prefix_mod_int(str,pn)
	if type(pn) == 'number' then pn = 'PlayerNumber_P'.. pn; end
	local state = GAMESTATE:GetPlayerState(pn);
	local mods = state:GetPlayerOptionsString('ModsLevel_Song');
	state:SetPlayerOptions('ModsLevel_Song',mods ..','.. str);
end

local function prefix_mod(str)
	for pn in ivalues(GAMESTATE:GetEnabledPlayers()) do
		prefix_mod_int(str,pn);
	end
end

local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)

		prefix_time = 0;

		prefix_mods = {
			{97.861,200,'*0.1875 2000x','end'},
		};

		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)

		--------------------------------------------------------
		-- Mod Reader Original by TaroNuke. Edited by WinDEU. --
		--------------------------------------------------------
		for i,v in pairs(prefix_mods) do
			if prefix_time >= v[1] then
				if (v[4] == 'len' and prefix_time <= v[1]+v[2]) or (v[4] == 'end' and prefix_time <= v[2]) then
					if table.getn(v) == 5 then
						prefix_mod_int(v[3],v[5]);
					else
						prefix_mod(v[3]);
					end
				end
			end
		end

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="test",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'music';playcommand,'SetTime';visible,false),
	SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
};

return t;