local function prefix_mod_int(str,pn)
	if type(pn) == 'number' then pn = 'PlayerNumber_P'.. pn; end
	local state = GAMESTATE:GetPlayerState(pn);
	local mods = state:GetPlayerOptionsString('ModsLevel_Song');
	state:SetPlayerOptions('ModsLevel_Song',mods ..','.. str);
end

local function prefix_mod(str)
	for pn in ivalues(GAMESTATE:GetEnabledPlayers()) do
		prefix_mod_int(str,pn);
	end
end

local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)

		prefix_path = GAMESTATE:GetCurrentSong():GetSongDir();
		prefix_time = 0;

		prefix_curmessage = 1;
		prefix_messages = {
		};

		local time = 76.283;
		while time < 111.528 do
			table.insert(prefix_messages,{time,'Suzaku'});
			if time <  89.780 then time = time+1.678*(math.random()+1);
		elseif time < 103.136 then time = time+0.839*(math.random()+1);
		elseif time < 106.493 then time = time+0.420*(math.random()+1);
		elseif time < 200.000 then time = time+0.210*(math.random()+1);
			end
		end

		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)

		--------------------
		-- Message Reader --
		--------------------
		if prefix_curmessage <= table.getn(prefix_messages) then
			if prefix_time >= prefix_messages[prefix_curmessage][1] then
				MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
				prefix_curmessage = prefix_curmessage + 1;
			end
		end

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="test",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'music';playcommand,'SetTime';visible,false),
	SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
};

t[#t+1] = Def.Quad{
	InitCommand=function(self) auxvar = self; self:visible(false); end,
	SuzakuMessageCommand=function() SOUND:PlayOnce(prefix_path..'lua/suzaku.ogg'); end,
};

t[#t+1] = Def.ActorFrame{
	InitCommand=function(self) self:SetDrawByZPosition(true) end,

	LoadActor("vanessa")..{ Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,SCREEN_CENTER_X*0.5;y,SCREEN_CENTER_Y;zoom,0;diffusealpha,0), SuzakuMessageCommand=cmd(stoptweening;zoom,0;diffusealpha,1;linear,1;zoom,4;diffusealpha,0) },
	LoadActor("vanessa")..{ Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_CENTER_X*1.5;y,SCREEN_CENTER_Y;zoom,0;diffusealpha,0), SuzakuMessageCommand=cmd(stoptweening;zoom,0;diffusealpha,1;linear,1;zoom,4;diffusealpha,0) },
};

return t;