local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)

		prefix_time = 0;

		prefix_curmessage = 1;
		prefix_messages = {
			{76.284,'PauseStart'},
			{78.898,'PauseEnd'},

			{89.322,'PauseStart'},
			{95.967,'PauseEnd'},

			{121.488,'PauseStart'},
			{122.152,'PauseEnd'},
		};

		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)

		--------------------
		-- Message Reader --
		--------------------
		if prefix_curmessage <= table.getn(prefix_messages) then
			if prefix_time >= prefix_messages[prefix_curmessage][1] then
				MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
				prefix_curmessage = prefix_curmessage + 1;
			end
		end

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="test",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'music';playcommand,'SetTime';visible,false),
	SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
};

t[#t+1] = Def.Quad{
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffuse,color('#000000');diffusealpha,0),
	PauseStartMessageCommand=cmd(linear,0.2;diffusealpha,0.8),
	PauseEndMessageCommand=cmd(linear,0.2;diffusealpha,0),
};

t[#t+1] = LoadActor("pause")..{
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,0),
	PauseStartMessageCommand=cmd(linear,0.2;zoom,1),
	PauseEndMessageCommand=cmd(linear,0.2;zoom,0),
};

return t;