local prefix_percent = 0;

local function prefix_mod_int(str,pn)
	if type(pn) == 'number' then pn = 'PlayerNumber_P'.. pn; end
	local state = GAMESTATE:GetPlayerState(pn);
	local mods = state:GetPlayerOptionsString('ModsLevel_Song');
	state:SetPlayerOptions('ModsLevel_Song',mods ..','.. str);
end

local function prefix_mod(str)
	for pn in ivalues(GAMESTATE:GetEnabledPlayers()) do
		prefix_mod_int(str,pn);
	end
end

local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	JudgmentMessageCommand=function(self,params)

		local beat = GAMESTATE:GetSongBeat();

		local rate = 16;
		if beat < 207 then rate = 2;
	elseif beat < 240 then rate = 4;
	elseif beat < 268 then rate = 8;
		end

		if params.TapNoteScore == 'TapNoteScore_HitMine' then prefix_percent = prefix_percent + 5*rate;
	elseif params.TapNoteScore == 'TapNoteScore_Miss'	 then prefix_percent = prefix_percent + 5*rate;
	elseif params.TapNoteScore == 'TapNoteScore_W5'		 then prefix_percent = prefix_percent + 4*rate;
	elseif params.TapNoteScore == 'TapNoteScore_W4'		 then prefix_percent = prefix_percent + 3*rate;
	elseif params.TapNoteScore == 'TapNoteScore_W3'		 then prefix_percent = prefix_percent + 2*rate;
	elseif params.TapNoteScore == 'TapNoteScore_W2'		 then prefix_percent = prefix_percent + 1*rate;
	elseif params.TapNoteScore == 'TapNoteScore_W1'		 then prefix_percent = prefix_percent - 2;
	elseif params.HoldNoteScore == 'HoldNoteScore_LetGo' then prefix_percent = prefix_percent + 5*rate;
	elseif params.HoldNoteScore == 'HoldNoteScore_Held'	 then prefix_percent = prefix_percent - 2;
		end

		prefix_percent = math.max(prefix_percent,0);
		prefix_percent = math.min(prefix_percent,1000);

		prefix_mod('*.125 '.. prefix_percent ..'% Tornado');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="0%",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;diffuse,color('#FF0000');playcommand,'Update'),
	UpdateCommand=function(self)
		self:settext('MADNESS\n'.. (prefix_percent or 0) ..'%');
		self:sleep(0.02);
		self:queuecommand('Update');
	end,
};

return t;