local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	JudgmentMessageCommand=function(self,params)

		local beat = GAMESTATE:GetSongBeat();

		if beat >= 175 and beat < 240 then
			for i,v in ipairs(GAMESTATE:GetEnabledPlayers()) do
				if params.Player == v then
					if params.TapNoteScore == 'TapNoteScore_Miss'	 then MESSAGEMAN:Broadcast('P'.. i ..'W6');
				elseif params.TapNoteScore == 'TapNoteScore_W5'		 then MESSAGEMAN:Broadcast('P'.. i ..'W5');
				elseif params.TapNoteScore == 'TapNoteScore_W4'		 then MESSAGEMAN:Broadcast('P'.. i ..'W4');
				elseif params.TapNoteScore == 'TapNoteScore_W3'		 then MESSAGEMAN:Broadcast('P'.. i ..'W3');
				elseif params.TapNoteScore == 'TapNoteScore_W2'		 then MESSAGEMAN:Broadcast('P'.. i ..'W2');
				elseif params.TapNoteScore == 'TapNoteScore_W1'		 then MESSAGEMAN:Broadcast('P'.. i ..'W1');
					end
				end
			end
		end
	end,
};

local p1 = Def.ActorFrame{
	OnCommand=cmd(x,SCREEN_CENTER_X*0.5;y,SCREEN_CENTER_Y),
};

for i = 1,10 do
	p1[#p1+1] = LoadActor("judgment")..{
		OnCommand=cmd(diffusealpha,0;animate,0),
		P1W6MessageCommand=cmd(finishtweening;setstate,5;playcommand,'Show'),
		P1W5MessageCommand=cmd(finishtweening;setstate,4;playcommand,'Show'),
		P1W4MessageCommand=cmd(finishtweening;setstate,3;playcommand,'Show'),
		P1W3MessageCommand=cmd(finishtweening;setstate,2;playcommand,'Show'),
		P1W2MessageCommand=cmd(finishtweening;setstate,1;playcommand,'Show'),
		P1W1MessageCommand=cmd(finishtweening;setstate,0;playcommand,'Show'),
		ShowCommand=cmd(x,math.random(-160,160);y,math.random(-240,240);diffusealpha,1;zoom,0.8;linear,0.05;zoom,1;sleep,0.2;linear,0.2;diffusealpha,0),
	};
end

t[#t+1] = p1;

local p2 = Def.ActorFrame{
	OnCommand=cmd(x,SCREEN_CENTER_X*1.5;y,SCREEN_CENTER_Y),
};

for i = 1,10 do
	p2[#p2+1] = LoadActor("judgment")..{
		OnCommand=cmd(diffusealpha,0;animate,0),
		P2W6MessageCommand=cmd(finishtweening;setstate,5;playcommand,'Show'),
		P2W5MessageCommand=cmd(finishtweening;setstate,4;playcommand,'Show'),
		P2W4MessageCommand=cmd(finishtweening;setstate,3;playcommand,'Show'),
		P2W3MessageCommand=cmd(finishtweening;setstate,2;playcommand,'Show'),
		P2W2MessageCommand=cmd(finishtweening;setstate,1;playcommand,'Show'),
		P2W1MessageCommand=cmd(finishtweening;setstate,0;playcommand,'Show'),
		ShowCommand=cmd(x,math.random(-160,160);y,math.random(-240,240);diffusealpha,1;zoom,0.8;linear,0.05;zoom,1;sleep,0.2;linear,0.2;diffusealpha,0),
	};
end

t[#t+1] = p2;

return t;