local function prefix_mod_int(str,pn)
	if type(pn) == 'number' then pn = 'PlayerNumber_P'.. pn; end
	local state = GAMESTATE:GetPlayerState(pn);
	local mods = state:GetPlayerOptionsString('ModsLevel_Song');
	state:SetPlayerOptions('ModsLevel_Song',mods ..','.. str);
end

local function prefix_mod(str)
	for pn in ivalues(GAMESTATE:GetEnabledPlayers()) do
		prefix_mod_int(str,pn);
	end
end

local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)
		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)
		prefix_mod('*10000 1x,*10000 C0,*10000 M0,*10000 Overhead');

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

return t;