local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)

		prefix_path = GAMESTATE:GetCurrentSong():GetSongDir();
		prefix_time = 0;

		prefix_curmessage = 1;
		prefix_messages = {
		};

		local time = 76.270;
		while time < 111.528 do
			table.insert(prefix_messages,{time,'Yes'});
			if time <  89.697 then time = time+1.678+3.357*math.random();
		elseif time < 103.123 then time = time+1.678+1.678*math.random();
		elseif time < 106.480 then time = time+1.678+0.839*math.random();
		elseif time < 111.528 then time = time+1.678+0.420*math.random();
			end
		end

		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)

		--------------------
		-- Message Reader --
		--------------------
		if prefix_curmessage <= table.getn(prefix_messages) then
			if prefix_time >= prefix_messages[prefix_curmessage][1] then
				MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
				prefix_curmessage = prefix_curmessage + 1;
			end
		end

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="test",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'music';playcommand,'SetTime';visible,false),
	SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
};

t[#t+1] = Def.Quad{
	InitCommand=function(self) auxvar = self; self:visible(false); end,
	YesMessageCommand=function()
		SOUND:PlayOnce(prefix_path..'lua/yes.ogg');
	end,
};

t[#t+1] = LoadActor("(yes)")..{
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffusealpha,0),
	YesMessageCommand=cmd(stoptweening;diffusealpha,1;sleep,0.5;linear,0.5;diffusealpha,0),
};

return t;